"""notebooksalamode.Dataset"""

import os.path
import pandas as pd

class Dataset(object):
    """Represets a Mode dataset"""

    data = None
    error = None
    name = None
    token = None

    def __init__(self, name, token, path=None, df=None):
        self.name = name
        self.token = token
        self.error = None

        if path is not None:
            self.path = path
            self.load()
            return

        if df is not None:
            self._data = df

    def load(self):
        """Populates a Pandas dataframe for this Dataset"""
        if os.path.isfile(self.path):
            stat = os.path.getsize(self.path)
            if stat > 0:
                self.data = pd.read_json(self.path, orient='records')
                self.error = False
                return

        self.data = pd.DataFrame({
            'Error Message' : ["Looks like something went wrong with your query"]
        })
        self.error = True
